*
**************************************************************************
* Author:       Michael Drozdov
* Description:  The program demonstrates a problem, which arises if in a DE class 
*               the attempt to open the not existing table is made. It is not possible
*               to overcome (skip error) from the code of program. It complicates 
*               use of DE class in not visual VFP-COM components.
* Restrictions: This code (as it's written) means using one database only in DE
*               Hm... and no any free tables :-)
* E-mail:       Mailto:Drozdov@ics.perm.su 
* My Page:      http://vfpdev.narod.ru/
* Date:         06/19/2003
**************************************************************************
*
#DEFINE USR_DATABASE	HOME(2)+"Data\TestData.dbc"
#DEFINE USR_TABLE		"products1"
*#DEFINE USR_TABLE		"products"
#DEFINE DE_CLS			"TestDE"

SET STEP ON
LOCAL loDE
loDE = NewObject(DE_CLS)
IF VARTYPE(loDE) # 'O'
	=MessageBox("Can not create object: "+DE_CLS, 16, _SCREEN.Caption)
	RETURN .F.
ENDIF
LOCAL lbRetVal
lbRetVal = loDE.OpenTables()
IF lbRetVal
	loDE.CloseTables()
	WAIT WINDOW "Ok"
ELSE
	WAIT WINDOW "Error"
ENDIF
RELEASE loDE

DEFINE CLASS TestDE AS DataEnvironment
	name = "TestDE"
	initialselectedalias = USR_TABLE
	
	ADD OBJECT Cursor1 AS Cursor WITH ;
		name = "Cursor1", ;
		alias = USR_TABLE, ;
		database = USR_DATABASE, ;
		cursorsource = USR_TABLE

ENDDEFINE